#include "node.h"

#include <unistd.h> /* getpagesize() */
#include <stdlib.h> /* getexecname() */
#include <strings.h> /* strncpy() */

#include <kstat.h>
#include <errno.h>
#include <inttypes.h>
#include <sys/types.h>
#include <sys/loadavg.h>
#include <sys/socket.h>
#include <net/if.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <fcntl.h>

#if (!defined(_LP64)) && (_FILE_OFFSET_BITS - 0 == 64)
#define PROCFS_FILE_OFFSET_BITS_HACK 1
#undef _FILE_OFFSET_BITS
#else
#define PROCFS_FILE_OFFSET_BITS_HACK 0
#endif

#include <procfs.h>

#if (PROCFS_FILE_OFFSET_BITS_HACK - 0 == 1)
#define _FILE_OFFSET_BITS 64
#endif


int GetMemory(size_t *rss) {
  psinfo_t psinfo;
  int fd;

  if ((fd = open("/proc/self/psinfo", O_RDONLY)) < 0)
    return -1;

  if (read(fd, &psinfo, sizeof (psinfo_t)) != sizeof (psinfo_t)) {
    (void) close(fd);
    return -1;
  }

  *rss = (size_t) psinfo.pr_rssize * 1024;
  (void) close(fd);

  return 0;
}